<?php
/* 
 * License: Copyright (c) 2008 Pawan Agrawal. All rights reserved.
 *
 * This code is part of commercial software and for your personal use 
 * only. You are not allowed to resell or distribute this script.
 *
 */
 
/**
 * MyTopCommentators - My Top Commentators
 * Holds all the necessary functions and variables
 */
class MyTopCommentators
{
	var $mtc_default_records_per_page = 25;
	var $mtc_default_comments_per_page = 25;
	var $mtc_default_time_frame = 'last7days';
	var	$mtc_time_frame_arr = array(
								'today' => 'Today (%today%)', 			    'yesterday' => 'Yesterday (%yesterday%)', 
								'last7days' => 'Last 7 Days', 				'thismonth' => 'This Month (%thismonth%)', 
								'lastmonth' => 'Last Month (%lastmonth%)',  'thisyear'  => 'This Year (%thisyear%)', 
								'lastyear'  => 'Last Year (%lastyear%)', 	'custom'    => 'Custom'
						        );
					
	/**
	 * Constructor.
	 */
	function MyTopCommentators() {}
	
	/**
	 * Page Header
	 */
	function __mtcHeader() {
		echo '<h2>'. MTC_NAME .' '. MTC_VERSION .'</h2>';	
	}
	
	/**
	 * Page Footer
	 */
	function __mtcFooter() {
		echo '<p style="text-align:center;margin-top:3em;"><strong>'. MTC_NAME .' '. MTC_VERSION .' by <a href="http://www.maxblogpress.com/" target="_blank" >MaxBlogPress</a></strong></p>';
	}
	
	/**
	 * Pagination function
	 * @param integer $mtc_pg Current page number
	 * @param integer $total_records Total number of records
	 * @param integer $start_no Record to start at
	 * @param integer $records_per_page No. of records in a page
	 * @param string $extra_params Additional parameters
	 */
	function __mtcPagination($mtc_pg, $total_records, $start_no, $records_per_page, $extra_params='') {
		$get_vars = 'page='.$_GET['page'].'&e='.urlencode($_GET['e']).'&t='.$_GET['t'].'&';
		$noof_pages = ceil($total_records/$records_per_page);
		
		for ( $i=1; $i<=$noof_pages; $i++ ) {
		   if ( $i == $mtc_pg ) {
		  	  $show_pages .= '&nbsp;<strong>'.$i.'</strong>&nbsp;';
		   } else {
		  	  $show_pages .= '&nbsp;<a href="'.MTC_SITEURL.'/wp-admin/index.php?'.$get_vars.'mtc_pg='.($i-1).'&'.$extra_params.'">'.$i.'</a>&nbsp;';
		   }
		}
		$show_pages = $show_pages;
		echo '<table align="center"><tr>';
		if ( $mtc_pg > 1 ) { $pages_shown = 1;
			  echo '<td><a href="'.MTC_SITEURL.'/wp-admin/index.php?'.$get_vars.'mtc_pg='.($mtc_pg-2).'&'.$extra_params.'">&laquo; Prev</a>
			  '.$show_pages.'</td>';
		}
		if ( $total_records > $records_per_page && ($total_records-$start_no) >= $records_per_page ) {
			  echo '<td>';
			  if ( $pages_shown != 1 ) echo $show_pages;
			  echo '<a href="'.MTC_SITEURL.'/wp-admin/index.php?'.$get_vars.'mtc_pg='.$mtc_pg.'&'.$extra_params.'">Next &raquo;</a>';
			  echo '</td>';
		}
		echo '</tr></table>';
	}
	
	/**
	 * Regenerates time frame array
	 */
	function __mtcGetTimeFrame() {
		$time_frame_array = array();
		$now   = date('Y-m-d H:i:s');
		$now   = getdate(time($now));
		$hrs   = $now['hours'];
		$mins  = $now['minutes'];
		$secs  = $now['seconds'];
		$year  = $now['year'];
		$month = $now['mon'];
		$day   = $now['mday'];
		$today     = $now['weekday'];
		$yesterday = date('l', mktime($hrs,$mins,$secs,$month,$day-1,$year));
		$thismonth = $now['month'];
		$lastmonth = date('F', mktime($hrs,$mins,$secs,$month-1,$day,$year));
		$thisyear  = $year;
		$lastyear  = date('Y', mktime($hrs,$mins,$secs,$month,$day,$year-1));
		foreach ( (array) $this->mtc_time_frame_arr as $key => $val ) {
			$val = str_replace('%today%', $today, $val);
			$val = str_replace('%yesterday%', $yesterday, $val);
			$val = str_replace('%thismonth%', $thismonth, $val);
			$val = str_replace('%lastmonth%', $lastmonth, $val);
			$val = str_replace('%thisyear%', $thisyear, $val);
			$val = str_replace('%lastyear%', $lastyear, $val);
			$time_frame_array[$key] = $val;
		}
		return $time_frame_array;
	}
	
	/**
	 * Gets 'date from' and 'date to' given the time frame
	 */
	function __mtcGetDateRange($time_frame) {
		$datef     = '';
		$datet     = '';
		$datetimef = '';
		$datetimet = '';
		if ( $time_frame == 'today' ) {
			$datef = date("Y-m-d");
			$datet = date("Y-m-d");
		} else if ( $time_frame == 'yesterday' ) {
			$yesterday_ts = mktime(0,0,0,date('m'),date('d')-1,date('Y'));
			$d 	   = date('d', $yesterday_ts);
			$m 	   = date('m', $yesterday_ts);
			$y 	   = date('Y', $yesterday_ts);
			$datef = date("$y-$m-$d");
			$datet = date("$y-$m-$d");
		} else if ( $time_frame == 'last7days' ) {
			$last7days_ts = mktime(0,0,0,date('m'),date('d')-7,date('Y'));
			$d     = date('d', $last7days_ts);
			$m     = date('m', $last7days_ts);
			$y     = date('Y', $last7days_ts);
			$datef = date("$y-$m-$d");
			$datet = date("Y-m-d");
		} else if ( $time_frame == 'thismonth' ) {
			$lastday = date('d', mktime(0,0,0,date('m')+1,0,date('Y')));
			$datef   = date("Y-m-01");
			$datet   = date("Y-m-$lastday");
		} else if ( $time_frame == 'lastmonth' ) {
			$lastmonth_ts = mktime(0,0,0,date('m')-1,date('d'),date('Y'));
			$m       = date('m', $lastmonth_ts);
			$y       = date('Y', $lastmonth_ts);
			$lastday = date('d', mktime(0,0,0,$m+1,0,date('Y')));
			$datef   = date("$y-$m-01");
			$datet   = date("$y-$m-$lastday");
		} else if ( $time_frame == 'thisyear' ) {
			$datef = date("Y-01-01");
			$datet = date("Y-12-31");
		} else if ( $time_frame == 'lastyear' ) {
			$lastyear_ts = mktime(0,0,0,date('m'),date('d'),date('Y')-1);
			$y     = date('Y', $lastyear_ts);
			$datef = date("$y-01-01");
			$datet = date("$y-12-31");
		} else if ( $time_frame == 'custom' ) {
			if ( $_GET['df'] == '' ) { // Comment list page
				$datef = $this->date_from;
				$datet = $this->date_to;
				$_date_from = explode('-',$datef);
				$_date_to   = explode('-',$datet);
				$datef      = $_date_from[2].'-'.$_date_from[0].'-'.$_date_from[1];
				$datet      = $_date_to[2].'-'.$_date_to[0].'-'.$_date_to[1];
			} else {
				$_datef = explode('-',$_GET['df']);
				$_datet = explode('-',$_GET['dt']);
				$datef = $_datef[2].'-'.$_datef[0].'-'.$_datef[1];
				$datet = $_datet[2].'-'.$_datet[0].'-'.$_datet[1];
			}
		}
		if ( $datef != '' ) {
			$datetimef = $datef.' 00:00:00';
			$_datef = explode('-',$datef);
			$datef = $_datef[1].'-'.$_datef[2].'-'.$_datef[0];
		}
		if ( $datet != '' ) {
			$datetimet = $datet.' 23:59:59';
			$_datet = explode('-',$datet);
			$datet = $_datet[1].'-'.$_datet[2].'-'.$_datet[0];
		}
		return array($datef,$datet,$datetimef,$datetimet);
	}
	
	/**
	 * Get commentators list from database
	 */
	function __mtcGetCommentators($time_frame) {
		$mtc_commentators_arr = array();
		list($datef,$datet,$datetimef,$datetimet) = $this->__mtcGetDateRange($time_frame);
		$sql = "SELECT COUNT(comment_ID) AS total_comments, comment_author, comment_author_email, comment_author_url FROM $this->comments_tbl 
				WHERE comment_approved='1' AND comment_author_email<>'' AND (comment_date >= '$datetimef' AND comment_date <= '$datetimet') 
				GROUP BY comment_author_email ORDER BY total_comments DESC, comment_author ASC";
		$rs = mysql_query($sql);
		while ( $row = mysql_fetch_assoc($rs) ) {
			$mtc_commentators_arr[] = array($row['comment_author'], $row['comment_author_email'], $row['comment_author_url'], $row['total_comments']);
		}
		return $mtc_commentators_arr;
	}
	
	/**
	 * Displays the top commentators list.
	 */
	function __mtcStatsPg() {
		$mtc_msg = '';
		$mtc_request = $_POST['mtc'];
		if ( isset($mtc_request['save_more_options']) ) {
			$this->mtc_options['time_frame'] = $mtc_request['default_time_frame'];
			$this->mtc_options['records_per_page'] = $mtc_request['records_per_page'];
			$this->mtc_options['comments_per_page'] = $mtc_request['comments_per_page'];
			update_option('mtc_options', $this->mtc_options);
			$mtc_msg = 'Options saved successfully.';
			return $mtc_msg;
		}
		if ( trim($_GET['e']) != '' ) {
			$this->mtcViewComments();
			exit;
		}
	}
	
	/**
	 * Displays the top commentators list.
	 */
	function __mtcShowStatsPg() {
		$mtc_get_vars    = 'page='.$_GET['page'].'&';
		$mtc_request     = $_POST['mtc'];
		$this->date_from = date('m-d-Y');
		$this->date_to   = date('m-d-Y');
		$mtc_date_from_to_disp = 'none';
		$mtc_date_td_width = '190';
		$pg_params = '';

		$this->time_frame_array = $this->__mtcGetTimeFrame();
		$this->mtc_time_frame = $this->mtc_options['time_frame'];
		$this->mtc_records_per_page = $this->mtc_options['records_per_page'];
		$this->mtc_comments_per_page = $this->mtc_options['comments_per_page'];
		if ( $mtc_request['generate_stats'] ) { // When 'generate stats' button clicked
			$_GET['mtc_pg'] = 0; // Reset pagination
			$this->mtc_time_frame = $mtc_request['time_frame'];
			$this->date_from = $mtc_request['date_form'];
			$this->date_to = $mtc_request['date_to'];
			$pg_params = 'tf='.$this->mtc_time_frame;
		} else if ( $_GET['tf'] != '' ) { // If pagination link clicked
			$this->mtc_time_frame = $_GET['tf'];
			$pg_params = 'tf='.$this->mtc_time_frame;
			if ( $_GET['dfrm'] != '' ) {
				$mtc_date_from_to_disp = strpos($_SERVER['HTTP_USER_AGENT'],'MSIE') ? 'block' : 'table-row';
				$mtc_date_td_width = '350';
				$this->date_from = $_GET['dfrm'];
				$this->date_to = $_GET['dto'];
				$pg_params .= '&dfrm='.$this->date_from.'&dto='.$this->date_to;
			}
			if ( $_GET['tf'] == 'custom' ) {
				$mtc_date_from_to = '&df='.$this->date_from.'&dt='.$this->date_to;
			}
		}
		if ( $mtc_request['time_frame'] == 'custom' ) {
			$mtc_date_from_to = '&df='.$mtc_request['date_form'].'&dt='.$mtc_request['date_to'];
			$mtc_date_from_to_disp = strpos($_SERVER['HTTP_USER_AGENT'],'MSIE') ? 'block' : 'table-row';
			$mtc_date_td_width = '350';
			$pg_params = 'tf='.$mtc_request['time_frame'];
			$pg_params .= '&dfrm='.$this->date_from.'&dto='.$this->date_to;
		}
			
		$this->mtc_commentators_arr = $this->__mtcGetCommentators($this->mtc_time_frame);
		$num_rows = count($this->mtc_commentators_arr);
		
		$this->__mtcHeader();
		require_once('home-pg.php');
		$this->__mtcFooter();
	}
	
	/**
	 * Displays the comments of a particular author.
	 */
	function __mtcViewComments() {
		$post_comments_arr = array();
		$mtc_get_vars = 'page='.$_GET['page'].'&';
		$comment_author_email = $_GET['e'];
		$date_from = $_GET['df'];
		$date_to = $_GET['dt'];
		
		$pg_params = '&df='.$date_from.'&dt='.$date_to;
		$this->mtc_time_frame = $this->mtc_options['time_frame'];
		$this->mtc_comments_per_page = $this->mtc_options['comments_per_page'];
		$this->time_frame_array = $this->__mtcGetTimeFrame();
		$_time_frame = $this->time_frame_array[$_GET['t']];
		list($_date_from,$_date_to,$_datetimef,$_datetimet) = $this->__mtcGetDateRange($_GET['t']);
		
		$sql = "SELECT t1.comment_ID, t1.comment_author, t1.comment_author_url, t1.comment_content, t1.comment_date, t2.ID, t2.post_title, t2.post_date 
				FROM $this->comments_tbl t1 INNER JOIN $this->posts_tbl t2 ON t1.comment_post_ID=t2.ID 
				WHERE t1.comment_author_email='$comment_author_email' AND t1.comment_approved='1' AND (comment_date >= '$_datetimef' AND comment_date <= '$_datetimet')
				ORDER BY comment_ID DESC";
		///print $sql;
		$rs = mysql_query($sql);
		$num_rows = mysql_num_rows($rs);
		while ( $row = mysql_fetch_assoc($rs) ) {
			$_comment_author = $row['comment_author'];
			$post_comments_arr[$row['ID']][] = array($row['post_title'], $row['post_date'], $row['comment_ID'], $row['comment_author'], $comment_author_email, $row['comment_author_url'], $row['comment_content'], $row['comment_date']);
		}
		
		$this->__mtcHeader();
		require_once('comments-made.php');
		$this->__mtcFooter();
	}
	
} // Eof Class

$MyTopCommentators = new MyTopCommentators();
?>