<?php
/* 
 * Plugin Name:   My Top Commentators
 * Version:       1.0
 * Plugin URI:    http://www.dailyblogtips.com/my-top-commentators-wordpress-plugin/
 * Description:   See who is the top commentators in your blog.
 * Author:        MaxBlogPress for Daily Blog Tips
 * Author URI:    http://www.maxblogpress.com
 *
 * License:       GNU General Public License
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 * 
 * Copyright (C) 2008 www.maxblogpress.com
 *
 */
 
$mtc_path     = preg_replace('/^.*wp-content[\\\\\/]plugins[\\\\\/]/', '', __FILE__);
$mtc_path     = str_replace('\\','/',$mtc_path);
$mtc_dir      = substr($mtc_path,0,strrpos($mtc_path,'/'));
$mtc_siteurl  = get_bloginfo('wpurl');
$mtc_siteurl  = (strpos($mtc_siteurl,'http://') === false) ? get_bloginfo('siteurl') : $mtc_siteurl;
$mtc_fullpath = $mtc_siteurl.'/wp-content/plugins/'.$mtc_dir.'/';
$mtc_relpath  = str_replace('\\','/',dirname(__FILE__));
$mtc_libpath  = $mtc_fullpath.'mtc-lib/';
define('MTC_PATH', $mtc_path);
define('MTC_LIBPATH', $mtc_libpath);
define('MTC_SITEURL', $mtc_siteurl);
define('MTC_NAME', 'My Top Commentators');
define('MTC_VERSION', '1.0');
require_once($mtc_relpath.'/mtc-lib/include/mtc.cls.php');

/**
 * MyTopCommentatorsPlugin - My Top Commentators
 * Holds all the necessary functions and variables
 */
class MyTopCommentatorsPlugin extends MyTopCommentators
{
	/**
	 * Constructor. Adds the plugins plugin actions/filters and gets the user defined options.
	 */
	function MyTopCommentatorsPlugin() {
		global $wpdb;
		$this->comments_tbl = $wpdb->comments;
		$this->posts_tbl    = $wpdb->posts;
		$this->img_home     = '<img src="'.MTC_LIBPATH.'images/home.gif" border="0" align="absmiddle">';
		$this->img_edit     = '<img src="'.MTC_LIBPATH.'images/edit.gif" border="0" align="absmiddle">';
		$this->img_delete   = '<img src="'.MTC_LIBPATH.'images/delete.gif" border="0" align="absmiddle">';
		$this->img_back     = '<img src="'.MTC_LIBPATH.'images/back.gif" border="0" align="absmiddle">';
		
		add_action('activate_'.MTC_PATH, array(&$this, 'mtcActivate'));
		add_action('admin_menu', array(&$this, 'mtcAddMenu'));
		if( !$this->mtc_options = get_option('mtc_options') ) {
			$this->mtc_options = array();
		}
	}
	
	/**
	 * Called when plugin is activated. Adds the plugins options to the options table.
	 */
	function mtcActivate() {
		$default_values = array('records_per_page' => $this->mtc_default_records_per_page, 'comments_per_page' => $this->mtc_default_comments_per_page, 'time_frame' => $this->mtc_default_time_frame);
		update_option('mtc_version', MTC_VERSION);
		if ( count($this->mtc_options) <= 0 ) {
			update_option('mtc_options', $default_values);
		}
		return true;
	}
	
	/**
	 * Adds the plugins link in admin's dashboard menu
	 */
	function mtcAddMenu() {
		add_submenu_page('index.php', 'My Top Commentators', MTC_NAME, 9, MTC_PATH, array(&$this, 'mtcStatsPg'));
	}
	
	/**
	 * Displays the top commentators list.
	 */
	function mtcStatsPg() {
		$mtc_msg = $this->__mtcStatsPg();
		if ( trim($mtc_msg) != '' ) {
			echo '<div id="message" class="updated fade"><p><strong>'.$mtc_msg.'</strong></p></div>';
		}
		echo '<div class="wrap">';
		$this->__mtcShowStatsPg();
		echo '</div>';
	}
	
	/**
	 * Displays the comments from a particular author.
	 */
	function mtcViewComments() {
		echo '<div class="wrap">';
		$this->__mtcViewComments();
		echo '</div>';
	}
	
} // Eof Class

$MyTopCommentatorsPlugin = new MyTopCommentatorsPlugin();
?>